#Variables store one element

x <- 25

#R can be used as a calculator


10 + 20
a = 4

#Or do calculations with a :
a * 5

#Concatenation function



x <- c(1,2,3,4,5)
x
y <- c("a", "b", "c", "d")
y


#Vectors
#Vectors have only 1 dimension and represent enumerated sequence of data. They can also store variables


v1 <- c(1,2,3,4)
mean (v1)

#The elements of a vector are specified/modified with braces (e.g. [number])


v1[1] <- 48
v1

#Display all workplace objects (variables, vectors etc.) via ls():

a= 10
b =20
ls()

#Useful tip : to save workplace and restore from a file use:

save.image(file="workspace.rda")
load(file="workspace.rda")

#Any function in R has help information

? mean
help(mean)

#Data types

x <- 1
mode(x)

y <- 3 < 4
y

a = "bioinfo"
mode(a)


#The main data objects in R :

#Matrices (single data type)

#Data frames (supports various data types)

#Lists (contains set of vectors)


m <- matrix(0,2,3)
m


#List contain various vectors. Each vectors in the list can be acessed by double braces [[number]]

x <- c(1,2,3,4)
y <- c(2,3,4)
L1 <- list(x,y)
L1


#Data frames are similar to matrices but can contain various data types

x <- c(1,5,10)

y <- c("A","B","C")
z <- data.frame(x,y)
z

#Duplicate data can be removed during analysis.


duplicated(c(1,2,1,3,1,4))





#To count the number of observations in each level of factor, we can use the R table() command as below:

data(iris)

table(iris$Species)


str(iris)

#If you want to combine data from different sources in R, you can combine different sets of data in three ways:

merged <-merge(iris,cars)

head(merged)


#To retrieve 5 rows and all columns of already built-in dataset iris, the below command, is used:

data(iris)

iris[1:5, ]


#R standard graphics available through package graphics, include several functions that provide statistical plots



plot(iris$Sepal.Length,iris$Petal.Length)


#A histogram is used to plot a continuous variable.

hist(iris[,1])
hist(iris[,2])
hist(iris[,3])


#boxplot
x <- c(1,5,10)
y <- c(20,30,40)
boxplot(x,y)



#We use heatmap for the intensity of colours. It is also used to display a relationship between two or three or many variables in a two-dimensional image
iris_filtered <- iris[,1:4]

heatmap(as.matrix(iris_filtered))



#circular plots in r

library("circlize")

mat = matrix(rnorm(36), 6, 6)

rownames(mat) = paste0("R", 1:6)

colnames(mat) = paste0("C", 1:6)



#draw network by igraph
#Define Nodes
nodes=cbind('id'=c('Fermenters','Methanogens','carbs','CO2','H2','other','CH4','H2O'),
            'type'=c(rep('Microbe',2),rep('nonBio',6)))
nodes

#Define Links
links=cbind('from'=c('carbs',rep('Fermenters',3),rep('Methanogens',2),'CO2','H2'),
            'to'=c('Fermenters','other','CO2','H2','CH4','H2O',rep('Methanogens',2)),
            'type'=c('uptake',rep('output',5),rep('uptake',2)),
            'weight'=rep(1,8))
#Make the network

library(ggridges)
library(ggplot2)
library(igraph)
net = graph_from_data_frame(links,vertices = nodes,directed = T)
plot(net)



#Change Appearance

colrs.v = c(nonBio = "lightblue",Microbe = "gold") #node colours
V(net)$color = colrs.v[V(net)$type]

colrs.e = c(output = "grey", uptake = "magenta") #edge colours
E(net)$color = colrs.e[E(net)$type]

plot(net, edge.curved=0.2,vertex.size=30) #make nodes bigger, curve arrows




#Density ridgeline plots

library(ggridges)
ggplot(iris, aes(x = Sepal.Length, y = Species)) + geom_density_ridges()




#We can also specify quantiles by cut points rather than number. E.g., we can indicate the 2.5% and 97.5% tails

ggplot(iris, aes(x = Sepal.Length, y = Species)) + stat_density_ridges(quantile_lines = TRUE, quantiles = c(0.025, 0.975), alpha = 0.7)


#another plot

ggplot(iris, aes(x=Sepal.Length, y=Species, fill = factor(stat(quantile)))) + stat_density_ridges( geom = "density_ridges_gradient", calc_ecdf = TRUE, quantiles = 4, quantile_lines = TRUE ) + scale_fill_viridis_d(name = "Quartiles")


#We can use the same approach to highlight the tails of the distributions.


ggplot(iris, aes(x = Sepal.Length, y = Species, fill = factor(stat(quantile)))) +
  stat_density_ridges(
    geom = "density_ridges_gradient",
    calc_ecdf = TRUE,
    quantiles = c(0.025, 0.975)
  ) +
  scale_fill_manual(
    name = "Probability", values = c("#FF0000A0", "#A0A0A0A0", "#0000FFA0"),
    labels = c("(0, 0.025]", "(0.025, 0.975]", "(0.975, 1]")
  )


#Data transformation


library("dplyr")

starwars %>%   filter(species == "Droid")










